#include <stdbool.h>
#include <stdio.h>

#define WIDTH 8
#define HEIGHT 8

bool walls[HEIGHT][WIDTH] =
{
  {1,1,1,1,1,1,1,1},
  {1,0,1,1,1,1,0,1},
  {1,0,1,0,0,1,0,1},
  {0,0,1,1,0,0,0,1},
  {1,0,1,1,0,1,0,1},
  {1,0,0,1,0,1,0,1},
  {1,1,0,0,0,1,1,1},
  {1,1,1,1,1,1,1,1}  
};

int startX = 6;
int startY = 1;

enum Direction
{
  pending, // Wand oder wir wissen es noch nicht
  isStartPoint,
  left, up, right, down
};

typedef enum Direction Direction;

// weil statisch, automatisch mit 0 == pending initialisiert
Direction directions[HEIGHT][WIDTH];

int endX, endY;

// Vorbedingung: x,y sind nicht am Rand
// Rckgabewert: Rand gefunden -> true
bool checkNeighbors(int x, int y)
{
  // noch zu verbessern: nicht viermal (oben/unten/links/rechts) fast der gleiche Code hintereinander

  // oben gucken
  if(!walls[y-1][x] && directions[y-1][x] == pending)
  {
    directions[y-1][x] = down;
    if(y-1 == 0) // Rand gefunden
    {
      endX = x;
      endY = y-1;
      return true;
    }
    else
    {
      bool r = checkNeighbors(x, y-1);
      if(r)
      {
        return true;
      }
    }
  }

  // unten gucken
  if(!walls[y+1][x] && directions[y+1][x] == pending)
  {
    directions[y+1][x] = up;
    if(y+1 == HEIGHT-1) // Rand gefunden
    {
      endX = x;
      endY = y+1;      
      return true;
    }
    else
    {
      bool r = checkNeighbors(x, y+1);
      if(r)
      {
        return true;
      }
    }
  }
  
  // links gucken
  if(!walls[y][x-1] && directions[y][x-1] == pending)
  {
    directions[y][x-1] = right;
    if(x-1 == 0) // Rand gefunden
    {
      endX = x-1;
      endY = y;     
      return true;
    }
    else
    {
      bool r = checkNeighbors(x-1, y);
      if(r)
      {
        return true;
      }
    }
  }

  // rechts gucken
  if(!walls[y][x+1] && directions[y][x+1] == pending)
  {
    directions[y][x+1] = left;
    if(x+1 == WIDTH-1) // Rand gefunden
    {
      endX = x+1;
      endY = y;
      return true;
    }
    else
    {
      bool r = checkNeighbors(x+1, y);
      if(r)
      {
        return true;
      }
    }
  }  
  
  return false;
}

// statisch: automatisch mit false gefllt
bool route[HEIGHT][WIDTH];

int main( void )
{
  directions[startY][startX] = isStartPoint;
  bool r = checkNeighbors(startX, startY);
  
  int x = endX;
  int y = endY;
  while(directions[y][x] != isStartPoint)
  {
    route[y][x] = true;
    switch(directions[y][x])
    {
    case down:
      y++;
      break;
    case up:
      y--;
      break;
    case right:
      x++;
      break;
    case left:
      x--;
      break;
    }
  }

  for(int i = 0; i < HEIGHT; i++)
  {
    for(int j = 0; j < WIDTH; j++)
    {
      if(route[i][j])
      {
        putchar('*');
      }
      else
      {
        putchar(' ');
      }
    }
    putchar('\n');    
  }
  
  return 0;
}
